unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, SQLite3Conn, SQLDB, DB, Forms, Controls, Graphics, Dialogs,
  StdCtrls, DBGrids;

type

  { TForm1 }

  TForm1 = class(TForm)
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    SQLite3Connection1: TSQLite3Connection;
    SQLQuery1: TSQLQuery;
    SQLTransaction1: TSQLTransaction;
    procedure DBGrid1EditingDone(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private

  public

  end;

Const
  CT='CREATE TABLE MyTable (ID INTEGER PRIMARY KEY, Bezeichnung VARCHAR(20), Bestand INTEGER DEFAULT 0, E_Preis REAL DEFAULT 0, G_Preis REAL GENERATED ALWAYS AS (Bestand*E_Preis) STORED);';
var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }


procedure TForm1.FormShow(Sender: TObject);
begin
  SQLite3Connection1.ExecuteDirect(CT);
  SQLQuery1.Active:=True;
  DBGrid1.Columns[0].Fieldname:='ID';
  DBGrid1.Columns[1].Fieldname:='Bezeichnung';
  DBGrid1.Columns[2].Fieldname:='Bestand';
  DBGrid1.Columns[3].Fieldname:='E_Preis';
  DBGrid1.Columns[4].Fieldname:='G_Preis';
end;

procedure TForm1.DBGrid1EditingDone(Sender: TObject);
begin
  SQLQuery1.ApplyUpdates;
  SQLQuery1.Refresh;
end;

end.

